/* tkcrypt.c created 23 May 03 22:01:17 by thk
   simple but good symmetric encryption-tool for keys with arbitrary length
   Time-stamp: <2003-05-26 22:40:03 thk>
*/

#include <stdio.h>

void *malloc();
#define MAXBUF  16*1024
unsigned char Buffer[MAXBUF];

/* if system is INTEL-type (little-endian) exchange byteorder from 12345678 43218765 */
#define INTELPOS(i) ((sizeof(unsigned long)-1-(i)%sizeof(unsigned long))+(int)((i)/sizeof(unsigned long))*sizeof(unsigned long))

unsigned long tkrand(seed)
  unsigned long seed;
{ return(seed*17+37); }

int encrypt(key)
  unsigned char *key;
{ int i, j, k, len, numvars, keylen, keypos, intel;
  unsigned long *randomvars, sum;
  unsigned char *randomkeys;

  len = strlen(key);
  numvars = ((len+1)*sizeof(unsigned char)+sizeof(unsigned long)-1)/sizeof(unsigned long)+1;

  /* fprintf(stderr,"encrypt(%s) len=%d vars=%d\n",key,len,numvars); */

  if (randomvars = malloc(sizeof(unsigned long)*numvars))
  { randomkeys = (unsigned char *)randomvars;

    /* find endiness of system */
    randomvars[0] = 1;
    intel = 0;
    if (randomkeys[0] == 1) { /* fprintf(stderr,"endiness = intel\n"); */ intel=1; }

    for (i=0; i<numvars; i++) randomvars[i] = 0;
    if (intel)
      for (i=0; i<numvars*sizeof(unsigned long) && key[i]; i++)
	 randomkeys[INTELPOS(i)] = key[i];
    else
      strcpy(randomkeys,key);

    for (i=0; i<numvars-1; i++) { sum += randomvars[i]; }
    randomvars[numvars-2] += sum; /* fill last key-seed if possibly not at boundary */
    randomvars[numvars-1]  = sum; /* create extra random-base */
    keylen = sizeof(unsigned long)*numvars-1;
    keypos = 0;

    /* fprintf(stderr,"beginning copied encrypt(%s) len=%d vars=%d keylen=%d\n",key,len,numvars,keylen); */

    while((len=fread(Buffer,1,MAXBUF,stdin))>0)
    { for (i=0; i<len; i++)
      { Buffer[i] ^= randomkeys[INTELPOS(keypos)];
	keypos++;
        if (keypos>=keylen)
	{ keypos=0;
	  /* change used keys in enigmatic way */
	  for (j=0; j<numvars; j++)
	  { for (k=randomvars[numvars-1]%4; k>=0; k--) randomvars[j] = tkrand(randomvars[j]);
	    randomvars[numvars-1] = tkrand(randomvars[numvars-1]);
	  }
	}
      }
      fwrite(Buffer,1,len,stdout);
    }
    free(randomvars);
  } else { fprintf(stderr,"no mem for %d random keys.\n",numvars); }
}

main(argc,argv)
  int  argc;
  char *argv[];
{ int  i, len;
  unsigned char *key;

  for (i=1; i<argc; i++) if (argv[i][0]=='-') switch(argv[i][1])
  { case 'h': printf("Usage: %s <key>  < from  > to\nen- or decrypts file with fiven key.\n",argv[0]);
	      exit(0);
              break;
  }

  for (i=1, len=0; i<argc; i++)
    if (argv[i][0]!='-') len+=strlen(argv[i])+1; /* append space */

  if (len<4) { fprintf(stderr,"Use minimum 4-character-key.\n"); exit(0); }

  if (key=malloc(sizeof(unsigned char)*len))
  { key[0] = '\0';
    for (i=1; i<argc; i++)
      if (argv[i][0]!='-') { strcat(key,argv[i]); strcat(key," "); }
    encrypt(key);
    free(key);
  } else { fprintf(stderr,"no mem for %d-character key.\n",len); }
}

